/* vim: set sw=8 ts=8 si et: */
/* Author: Guido Socher, Copyright: GPL */
#include <stdio.h>
#include <string.h>
#include "config.h"
/*
 * generate a hash key from a string of any lenght. The string
 * must be nul-char terminated (normal C string).
 * The modulo operation should be done using a prime number.
 * primes are e.g :29,47,59,71,127,223,241,307,509,701,809,1201
 * 1201,1409, 2003,3001,5003,10007,20011,30011,50021
 */

int genhashkey(char *somestring) 
{
        int i, curr, hash;
        i = 0;
        hash = 0;
        /*ignore leading space */
        while (*somestring && *somestring == ' ') {
                somestring++;
        }
        while (*somestring && *somestring != ' ') {
                curr = (int) *somestring;
                hash = ((i + curr) * (i + curr) + hash) % 20011;
                i++; somestring++;
        }
        return (hash);
}
